<?
/**************************************************************************************
*    DB Framework for PHP 1.6.                                                        *
*    Copyright (C) 2004-2009 Luca Bertoncello                                         *
*    Hartigstrae, 12 - 01127 Dresden Deutschland                                     *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                              *
*    http://www.lucabert.de/  http://www.lucabert.com/                                *
*                                                                                     *
*    This program is free software; you can redistribute it and/or modify             *
*    it under the terms of the GNU General Public License as published by             *
*    the Free Software Foundation; version 2 of the License.                          *
*                                                                                     *
*    This program is distributed in the hope that it will be useful,                  *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of                   *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                    *
*    GNU General Public License for more details.                                     *
*                                                                                     *
*    You should have received a copy of the GNU General Public License                *
*    along with this program; if not, write to the Free Software                      *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA        *
**************************************************************************************/

/*****************************************************************************************
* Set here all data for this DB-Class:                                                   *
*                                                                                        *
* $CLASSNAME            : Name of the Class                                              *
* $DBFIELDSNAME         : Array with the Names of the Fields of the DB-Table             *
* $DBFIELDSTYPE         : Array with the Types of the Fields.                            *
*                         Valid Types are:                                               *
*                         - Int                                                          *
*                         - Binary                                                       *
*                         - String                                                       *
*                         - DBFDateTime                                                  *
*                         If the Field is a Foreign Key on another Table,                *
*                         simply write the name of the DB-Class.                         *
* $DBFIELDSNULL         : Array with the Null attributes of the Fields:                  *
*                         - = 1 -> Null               (Constant CANNULL)                 *
*                         - = 0 -> Not Null           (Constant NOTNULL)                 *
* $DBTABLE              : Name of the Table on DB                                        *
* $DBIDFIELD            : Name of the ID Field                                           *
* $DEBUGSQL             : = 0 -> Quiet mode           (Constant QUIET)                   *
*                         = 1 -> Print SQL Statement  (Constant VERBOSE)                 *
*                                                                                        *
* Example:                                                                               *
* $CLASSNAME            = "AddBook";                                                     *
* $DBFIELDSNAME         = array('Name'  , 'Age'   , 'EMail' , 'LastLogon',    'Foto');   *
* $DBFIELDSTYPE         = array('String', 'Int'   , 'String', 'DBFDateTime',  'Binary'); *
* $DBFIELDSNULL         = array( NOTNULL,  CANNULL,  NOTNULL,  CANNULL,        CANNULL); *
* $DBTABLE              = 'addressBook';                                                 *
* $DBIDFIELD            = 'Id';                                                          *
* $DEBUGSQL             = QUIET;                                                         *
*****************************************************************************************/

define("CANNULL", 1);
define("NOTNULL", 0);
define("VERBOSE", 1);
define("QUIET"  , 0);

define("SORT_ASCEND",  "ASC");
define("SORT_DESCEND", "DESC");

$CLASSNAME            = '';
$DBFIELDSNAME         = array();
$DBFIELDSTYPE         = array();
$DBFIELDSNULL         = array();
$DBTABLE              = '';
$DBIDFIELD            = '';
$DEBUGSQL             = QUIET;



/*******************************************************************************
* Auto-generating code: Do not modify!!                                        *
*******************************************************************************/

$DBTMPSTRCLASS = "
class $CLASSNAME
{
  var \$DEBUGSQL             = $DEBUGSQL;
  var \$CLASSNAME            = '$CLASSNAME';
  var \$id;
  var \$DBFIELDSNAME         = array(";

for($l = 0; $l < sizeof($DBFIELDSNAME); $l++)
  {
    $DBTMPSTRCLASS         .= "'$DBFIELDSNAME[$l]'";
    if($l < (sizeof($DBFIELDSNAME) - 1))
      $DBTMPSTRCLASS       .= ', ';
  }

$DBTMPSTRCLASS .= ");
  var \$DBFIELDSTYPE         = array(";

for($l = 0; $l < sizeof($DBFIELDSTYPE); $l++)
  {
    $DBTMPSTRCLASS         .= "'$DBFIELDSTYPE[$l]'";
    if($l < (sizeof($DBFIELDSTYPE) - 1))
      $DBTMPSTRCLASS       .= ', ';
  }

$DBTMPSTRCLASS .= ");
  var \$DBFIELDSNULL         = array(";

for($l = 0; $l < sizeof($DBFIELDSNULL); $l++)
  {
    $DBTMPSTRCLASS         .= "'$DBFIELDSNULL[$l]'";
    if($l < (sizeof($DBFIELDSNULL) - 1))
      $DBTMPSTRCLASS       .= ', ';
  }

$DBTMPSTRCLASS .= ");
  var \$DBTABLE              = '$DBTABLE';
  var \$fields;

  function areAllFieldFilled()
  {
    \$ret = 1;
    for(\$l = 0; \$l < sizeof(\$this->DBFIELDSNULL); \$l++)
      if(\$this->DBFIELDSNULL[\$l] == NOTNULL)
        {
          switch(\$this->DBFIELDSTYPE[\$l])
            {
              case 'Int':
                if(\$this->fields{\$this->DBFIELDSNAME[\$l]} === NULL)
                  \$ret = 0;
              break;
              case 'Binary':
              case 'String':
              case 'DBFDateTime':
                if(\$this->fields{\$this->DBFIELDSNAME[\$l]} == '')
                  \$ret = 0;
              break;
              default:
                if(\$this->fields{\$this->DBFIELDSNAME[\$l]} === NULL)
                  \$ret = 0;
              break;
            }
        }

    return \$ret;
  }

  function createQueryFormat(\$nCol)
  {
    \$type                   = \$this->DBFIELDSTYPE[\$nCol];
    if(\$type != 'DBFDateTime')
      return \$this->DBFIELDSNAME[\$nCol];
    else
      {
        return 'DATE_FORMAT('.\$this->DBFIELDSNAME[\$nCol].\", '%Y-%m-%d-%H-%i-%s') AS \".\$this->DBFIELDSNAME[\$nCol];
      }
  }

  function setAllFields($".strtolower(substr($DBIDFIELD, 0, 1)).substr($DBIDFIELD, 1).", ";

for($l = 0; $l < sizeof($DBFIELDSNAME); $l++)
  {
    $DBTMPNAME        = $DBFIELDSNAME[$l];
    $DBTMPNAME        = strtolower(substr($DBTMPNAME, 0, 1)).substr($DBTMPNAME, 1);
    $DBTMPSTRCLASS   .= '$'.$DBTMPNAME;
    if($l < (sizeof($DBFIELDSNAME) - 1))
      $DBTMPSTRCLASS .= ", ";
  }

$DBTMPSTRCLASS .= ")
  {
    \$this->id           = \$id;
";

for($l = 0; $l < sizeof($DBFIELDSNAME); $l++)
  {
    $DBTMPNAME        = $DBFIELDSNAME[$l];
    $DBTMPNAME        = strtolower(substr($DBTMPNAME, 0, 1)).substr($DBTMPNAME, 1);
    switch($DBFIELDSTYPE[$l])
      {
        case 'Binary':
          $DBTMPSTRCLASS   .= "    \$this->fields{".$DBFIELDSNAME[$l]."} = stripcslashes(stripslashes($".$DBTMPNAME."));\n";
        break;
        case 'Int':
        case 'String':
          $DBTMPSTRCLASS   .= "    \$this->fields{".$DBFIELDSNAME[$l]."} = stripslashes($".$DBTMPNAME.");\n";
        break;
        case 'DBFDateTime':
          $DBTMPSTRCLASS   .= "    \$this->fields{".$DBFIELDSNAME[$l]."} = new DBFDateTime($".$DBTMPNAME.", '%Y-%M-%D-%H-%I-%S');\n";
        break;
        default:
          $DBTMPSTRCLASS   .= "    \$this->fields{".$DBFIELDSNAME[$l]."} = new ".$DBFIELDSTYPE[$l]."($".$DBTMPNAME.");\n";
        break;
      }
  }

$DBTMPSTRCLASS .= "  }

  function $CLASSNAME(\$id = -1)
  {
    \$l                      = sizeof(\$this->DBFIELDSNAME);
    \$this->fields           = array(\$l);

    if(\$id == -1)
      {
        for(\$l = 0; \$l < sizeof(\$this->DBFIELDSNAME); \$l++)
          switch(\$this->DBFIELDSTYPE[\$l])
            {
              case 'Int':
                \$this->fields{\$l} = 0;
              break;
              case 'Binary':
              case 'String':
              case 'DBFDateTime':
                \$this->fields{\$l} = '';
              break;
              default:
                \$this->fields{\$l} = 0;
              break;
            }
      }
    else
      {
        \$this->id           = \$id;
        \$query              = '';
        for(\$l = 0; \$l < sizeof(\$this->DBFIELDSNAME); \$l++)
          if(\$query == '')
            \$query          = \"SELECT \".\$this->createQueryFormat(\$l);
          else
            \$query         .= ', '.\$this->createQueryFormat(\$l);
        \$query             .= \" FROM \$this->DBTABLE WHERE $DBIDFIELD=\$id\";

        if(\$this->DEBUGSQL != QUIET)
          print \"query: [\$query]<br>\\n\";

        \$result = dbQuery(\$query);
        \$row = dbFetchArray(\$result);
        for(\$l = 0; \$l < sizeof(\$this->DBFIELDSNAME); \$l++)
          switch(\$this->DBFIELDSTYPE[\$l])
            {
              case 'Binary':
                \$this->fields{\$this->DBFIELDSNAME[\$l]} = base64_decode(stripslashes(\$row[\$this->DBFIELDSNAME[\$l]]));
              break;
              case 'Int':
              case 'String':
                \$this->fields{\$this->DBFIELDSNAME[\$l]} = stripslashes(\$row[\$this->DBFIELDSNAME[\$l]]);
              break;
              case 'DBFDateTime':
                \$this->fields{\$this->DBFIELDSNAME[\$l]} = new DBFDateTime(\$row[\$this->DBFIELDSNAME[\$l]], '%Y-%M-%D-%H-%I-%S');
              break;
              default:
                \$this->fields{\$this->DBFIELDSNAME[\$l]} = new \$this->DBFIELDSTYPE[\$l](\$row[\$this->DBFIELDSNAME[\$l]]);
              break;
            }

        dbFreeRestult(\$result);
      }
  }

";

$DBTMPNAME = $DBIDFIELD;
$DBTMPNAME = strtolower(substr($DBTMPNAME, 0, 1)).substr($DBTMPNAME, 1);
$DBTMPSTRCLASS .= "  function $DBTMPNAME()      { return \$this->id; }\n";

for($l = 0; $l < sizeof($DBFIELDSNAME); $l++)
  {
    $DBTMPNAME      = $DBFIELDSNAME[$l];
    $DBTMPNAME      = strtolower(substr($DBTMPNAME, 0, 1)).substr($DBTMPNAME, 1);
    $DBTMPSTRCLASS .= "  function $DBTMPNAME()      { return \$this->fields{'$DBFIELDSNAME[$l]'}; }\n";
    $DBTMPSTRCLASS .= "  function set$DBFIELDSNAME[$l](\$value)   { \$this->fields{'$DBFIELDSNAME[$l]'} = \$value; }\n";
  }

$DBTMPSTRCLASS .= "
  function save()
  {
    if(\$this->areAllFieldFilled())
      {
        \$query          = '';
        for(\$l = 0; \$l < sizeof(\$this->DBFIELDSNAME); \$l++)
          {
            if(\$query == '')
              \$query      = \"UPDATE \$this->DBTABLE SET \".\$this->DBFIELDSNAME[\$l].'=';
            else
              \$query     .= ', '.\$this->DBFIELDSNAME[\$l].'=';
            switch(\$this->DBFIELDSTYPE[\$l])
              {
                case 'Int':
                  \$query .= \$this->fields{\$this->DBFIELDSNAME[\$l]};
                break;
                case 'Binary':
                  \$query .= \"'\".addslashes(base64_encode(\$this->fields{\$this->DBFIELDSNAME[\$l]})).\"'\";
                break;
                case 'String':
                  \$query .= \"'\".addslashes(\$this->fields{\$this->DBFIELDSNAME[\$l]}).\"'\";
                break;
                case 'DBFDateTime':
                  \$tmp    = \$this->fields{\$this->DBFIELDSNAME[\$l]};
                  if(\$tmp->toString('%Y-%M-%D') == '0000-00-00')
                    \$query .= \"'\".\$tmp->toString('%H:%I:%S').\"'\";
                  else
                    \$query .= \"'\".\$tmp->toString('%Y-%M-%D %H:%I:%S').\"'\";
                break;
                default:
                  \$tmp    = \$this->fields{\$this->DBFIELDSNAME[\$l]};
                  \$query .= \$tmp->id();
                break;
              }
          }
        \$query         .= \" WHERE $DBIDFIELD=\".\$this->id;

        if(\$this->DEBUGSQL != QUIET)
          print \"query: [\$query]<br>\\n\";

        \$result         = dbQuery(\$query);
        if(!\$result)
          dbError(\$this->DBTABLE, 'Update '.\$this->CLASSNAME.' failed!!');
      }
    else
      dbError(\$this->DBTABLE, 'Not all mandatory fields in '.\$this->CLASSNAME.' have a value');
  }

  function create()
  {
    if(\$this->areAllFieldFilled())
      {
        \$query            = '';
        for(\$l = 0; \$l < sizeof(\$this->DBFIELDSNAME); \$l++)
          if(\$query == '')
            \$query        = \"INSERT INTO \$this->DBTABLE (\".\$this->DBFIELDSNAME[\$l];
          else
            \$query       .= ', '.\$this->DBFIELDSNAME[\$l];
        \$query           .= ') VALUES(';
        for(\$l = 0; \$l < sizeof(\$this->DBFIELDSNAME); \$l++)
          {
            if(\$l != 0)
              \$query     .= ', ';
            switch(\$this->DBFIELDSTYPE[\$l])
              {
                case 'Int':
                  \$query .= \$this->fields{\$this->DBFIELDSNAME[\$l]};
                break;
                case 'Binary':
                  \$query .= \"'\".addslashes(base64_encode(\$this->fields{\$this->DBFIELDSNAME[\$l]})).\"'\";
                break;
                case 'String':
                  \$query .= \"'\".addslashes(\$this->fields{\$this->DBFIELDSNAME[\$l]}).\"'\";
                break;
                case 'DBFDateTime':
                  \$tmp    = \$this->fields{\$this->DBFIELDSNAME[\$l]};
                  if(\$tmp->toString('%Y-%M-%D') == '0000-00-00')
                    \$query .= \"'\".\$tmp->toString('%H:%I:%S').\"'\";
                  else
                    \$query .= \"'\".\$tmp->toString('%Y-%M-%D %H:%I:%S').\"'\";
                break;
                default:
                  \$tmp    = \$this->fields{\$this->DBFIELDSNAME[\$l]};
                  \$query .= \$tmp->id();
                break;
              }
          }
        \$query           .= ')';

        if(\$this->DEBUGSQL != QUIET)
          print \"query: [\$query]<br>\\n\";

        \$result         = dbQuery(\$query);
        \$this->id       = dbInsertedId();
        if(!\$result)
          dbError(\$this->DBTABLE, 'Insert '.\$this->CLASSNAME.' failed!!');
      }
    else
      dbError(\$this->DBTABLE, 'Not all mandatory fields in '.\$this->CLASSNAME.' have a value');
  }

  function delete()
  {
    \$query          = \"DELETE FROM \$this->DBTABLE WHERE $DBIDFIELD=\".\$this->id;

    if(\$this->DEBUGSQL != QUIET)
      print \"query: [\$query]<br>\\n\";

    \$result         = dbQuery(\$query);
    if(!\$result)
      dbError(\$this->DBTABLE, 'Delete '.\$this->CLASSNAME.' failed!!');
  }
}

";

$DBTMPNAME          = $CLASSNAME;
$DBTMPNAME          = "getAll".strtoupper(substr($DBTMPNAME, 0, 1)).substr($DBTMPNAME, 1);
if(substr(strrev($DBTABLE), 0, 1) != 's')
  $DBTMPNAME       .= 's';
$DBTMPSTRCLASS     .= "function $DBTMPNAME(\$cond = '', \$order = '', \$sort = '')";

$DBTMPSTRCLASS     .= "
{";
  $query            = '';
  $DBTMPNAME        = '$rs->'.$DBIDFIELD.', ';
  for($l = 0; $l < sizeof($DBFIELDSNAME); $l++)
    {
      $DBTMPNAME   .= "\$rs->".$DBFIELDSNAME[$l];
      if($l < (sizeof($DBFIELDSNAME) - 1))
        $DBTMPNAME .= ', ';
      if($DBFIELDSTYPE[$l] != 'DBFDateTime')
        $DBTMPSEL   = $DBFIELDSNAME[$l];
      else
        $DBTMPSEL   = 'DATE_FORMAT('.$DBFIELDSNAME[$l].", '%Y-%m-%d-%H-%i-%s') AS ".$DBFIELDSNAME[$l];
      if($query == '')
        $query      = "SELECT $DBIDFIELD, ".$DBTMPSEL;
      else
        $query     .= ', '.$DBTMPSEL;
    }

$DBTMPSTRCLASS .= "
  \$query        = \"$query FROM $DBTABLE\";
  if(\$cond != '')
    \$query     .= ' WHERE '.\$cond;
  if(\$order != '')
    \$query     .= ' ORDER BY '.\$order;
  if(\$order != '' && \$sort != '')
    \$query     .= ' '.\$sort;

  if($DEBUGSQL != QUIET)
    print \"query: [\$query]<br>\\n\";
  \$result       = dbQuery(\$query) or dbError('$DBTABLE', 'Query failed');

  \$ret          = array();
  while(\$rs = dbFetch(\$result))
    {
      \$record   = new $CLASSNAME();
      \$record->setAllFields($DBTMPNAME);
      \$ret[]   = \$record;
    }
  dbFreeRestult(\$result);

  return(\$ret);
}
";

eval($DBTMPSTRCLASS);

/*****************************************
 * Uncomment it, if you want to see      *
 * generated code                        *
******************************************/
//print $DBTMPSTRCLASS;

/*****************************************
 * Delete all used variables             *
******************************************/
unset($CLASSNAME);
unset($DBFIELDSNAME);
unset($DBFIELDSTYPE);
unset($DBFIELDSNULL);
unset($DBTABLE);
unset($DBIDFIELD);
unset($DEBUGSQL);
unset($DBTMPSTRCLASS);
unset($l);
unset($DBTMPNAME);
?>
